// KNIHOVNA pro obsluhu digitlnhoteplotnho idla DALLAS (DS18B20)
// autor : Petr Navrtil
// verze 1.3 - hlavikov - soubor

#ifndef DS18B20
#define DS18B20

#include <avr/io.h>
#include <util/delay.h>

// prototypy funkc
void reset (void);			// funkce pro reset teplotnho idla
int16_t Read_Teplota(void);        	// pete celou hodnotu teploty a ulo do hodnota, ta je typu int16_t	
void Write_Bus (int prikaz);		// vyle dan kd do teplotnho idla
void presnost_cidla(unsigned char nastav);      	// mn rozlien idla 9,10,11 a 12 bitov pesnost
void alarm_zmena(unsigned char T_hor, unsigned char T_dol, unsigned char presnost); // zmna nastaven mez pro sputn alarmu

// pomocn podrpogramy
int16_t cteni (unsigned char pozice, int16_t hodnota);		// precti bit
void zapis_1 (void);		 	// zapise logickou 1 do zarizeni
void zapis_0 (void);			// zapise logickou 0 do zarizeni
void zapis_scratch (unsigned char presnost);

#define DDRQ DDRA
#define PORTQ PORTA
#define PINQ PINA



#endif /* DS18B20 */
