// knihovna pro ENC28J60
// autor: Petr Navrtil

#ifndef enc28j60_h
#define enc28j60_h

#include <avr/io.h>

// prototypy funkc
void SPI_SendIns (unsigned char OPCODE, unsigned char argument);
void SPI_sendDATA(unsigned char Data);
unsigned char SPI_readDATA(void);
void SysReset (void);
void writeReg (unsigned char OPCODE, unsigned char adresa, unsigned char data);
unsigned char readReg (unsigned char OPCODE, unsigned char adresa);
void Init_ENC (unsigned char *poziceMAC);
void SetBank (unsigned char banka);
void WriteBuffer(unsigned char *poziceENC, unsigned char pocet);
void SendPacket (unsigned char pozice);
void TxReset (void);
void RxReset (void);
// nepouit funkce v tomto projektu
void WriteENC (unsigned char OPCODE, unsigned char adresa, unsigned char *pozice, unsigned char delka );
void ReadENC (unsigned char OPCODE, unsigned char adresa, unsigned char *pozice, unsigned char delka );
void ReadBuffer(unsigned char *pozicePAK, uint16_t adresa);
void ReadPacketData(unsigned char *pozicePAK, uint16_t adresa);


// globln promnn
unsigned char stavReg;




// SPI komunikace - posln dat CS = PORTD 6
#define CS_out      DDRB |= 0b00010000		// CS nastaven jako vstupn
#define CS_set		PORTB |=0b00010000
#define CS_clear	PORTB &=0b11101111


//------------------------
//adresy registr v ENC28J60 (argumenty)

// reg obsaen ve vech bankch
#define ECON1 		0x1F 	// v tomto registru se specifikuj jednotliv banky pomoc bit BEL1, BEL0
#define ECON2	 	0x1E
#define ESTAT		0x1D
#define EIR 		0x1C
#define EIE 		0x1B

// banka 0
#define ERDPTL		0x00
#define ERDPTH		0x01
#define EWRPTL		0x02
#define EWRPTH		0x03
#define ETXSTL		0x04
#define ETXSTH		0x05
#define ETXNDL		0x06
#define ETXNDH		0x07
#define ERXSTL		0x08
#define ERXSTH		0x09
#define ERXNDL		0x0A
#define ERXNDH		0x0B
#define ERXRDPTL	0x0C
#define ERXRDPTH	0x0D
#define ERXWRPTL	0x0E
#define ERXWRPTH	0x0F
#define EDMASTL		0x10
#define EDMASTH		0x11
#define EDMANDL		0x12
#define EDMANDH		0x13
#define EDMADSTL	0x14
#define EDMADSTH	0x15
#define EDMACSL		0x16
#define EDMACSH		0x17

//banka 1
#define EHT0		0x00
#define EHT1		0x01
#define EHT2		0x02
#define EHT3		0x03
#define EHT4		0x04
#define EHT5		0x05
#define EHT6		0x06
#define EHT7		0x07
#define EPMM0		0x08
#define EPMM1		0x09
#define EPMM2		0x0A
#define EPMM3		0x0B
#define EPMM4		0x0C
#define EPMM5		0x0D
#define EPMM6		0x0E
#define EPMM7		0x0F
#define EPMCSL		0x10
#define EPMCSH		0x11
#define EPMOL		0x14
#define EPMOH		0x15
#define ERXFCON		0x18
#define EPKTCNT		0x19

//banka 2
#define MACON1		0x00
#define MACON3		0x02
#define MACON4		0x03
#define MABBIPG		0x04
#define MAIPGL		0x06
#define MAIPGH		0x07
#define MACLCON1	0x08
#define MACLCON2	0x09
#define MAMXFLL		0x0A
#define MAMXFLH		0x0B
#define MICMD		0x12
#define MIREGADR	0x14
#define MIWRL		0x16
#define MIWRH		0x17
#define MIRDL		0x18
#define MIRDH		0x19

//banka 3
#define MAADR5		0x00
#define MAADR6		0x01
#define MAADR3		0x02
#define MAADR4		0x03
#define MAADR1		0x04
#define MAADR2		0x05
#define EBSTSD		0x06
#define EBSTCON		0x07
#define EBSTCSL		0x08
#define EBSTCSH		0x09
#define MISTAT		0x0A
#define EREVID		0x12
#define ECOCON		0x15
#define EFLOCON		0x17
#define EPAUSL		0x18
#define EPAUSH		0x19



//OPCODE pro ENC28J60
#define	ReadConReg 		0x00	// nesjou dle data
#define ReadBuffMem 	0x01	// nejsou dle data
#define	WriteConReg		0x02
#define	WriteBuffMem	0x03
#define	BitFieldSet		0x04
#define	BitFieldClear	0x05
#define	SysResComm		0x06	// nejsou dle data

//adresa bufferu
#define	BuffAdress		0x1A	// 11010

#endif /* enc28j60 */
